import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { getControl, createNode } from 'handie-vue';
import { RelationFieldStructuralWidget } from 'handie-vue/dist/widgets';
let SelectEditM2oFilterWidget = class SelectEditM2oFilterWidget extends RelationFieldStructuralWidget {
    constructor() {
        super(...arguments);
        this.options = [];
    }
    render(h) {
        const children = this.options.map(opt => createNode(h, 'Option', {
            props: { label: opt[this.labelKey], value: opt[this.valueKey] },
        }));
        const showEmptyValueOption = this.getCommonBehavior('filter.showEmptyValueOption', false);
        if (showEmptyValueOption) {
            children.unshift(createNode(h, 'Option', {
                props: { label: this.getCommonBehavior('filter.emptyValueOptionLabel'), value: '' },
            }));
        }
        return h(getControl('Select'), {
            props: {
                value: this.internalValue,
                placeholder: this.getPlaceholder(),
                clearable: !showEmptyValueOption,
            },
            on: { change: value => this.onChange(value == null ? '' : value) },
        }, children);
    }
    created() {
        this.fetchRelatedList({}, data => (this.options = data));
    }
};
SelectEditM2oFilterWidget = __decorate([
    Component
], SelectEditM2oFilterWidget);
export default SelectEditM2oFilterWidget;
