import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isNumber, pick, getControl, createNode } from 'handie-vue';
import { MultiEnumFilterStructuralWidget } from 'handie-vue/dist/widgets';
let SelectEditMultiEnumFilterWidget = class SelectEditMultiEnumFilterWidget extends MultiEnumFilterStructuralWidget {
    handleOptionChange(value) {
        this.onChange(value);
        if (this.searchImmediately) {
            this.$$search.submit();
        }
    }
    render(h) {
        const props = {
            value: this.value,
            placeholder: this.getPlaceholder(),
            multiple: true,
        };
        const { className, width } = this.config;
        if (className) {
            props.className = className;
        }
        if (width) {
            props.style = { width: isNumber(width) ? `${width}px` : width };
        }
        return h(getControl('Select'), { props, on: { change: this.handleOptionChange } }, this.options.map(opt => createNode(h, 'Option', {
            props: pick(opt, ['label', 'value']),
            key: `Option${opt.value}OfSelectEditMultiEnumFilterWidget`,
        })));
    }
};
SelectEditMultiEnumFilterWidget = __decorate([
    Component
], SelectEditMultiEnumFilterWidget);
export default SelectEditMultiEnumFilterWidget;
