import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isBoolean, capitalize, getControl } from 'handie-vue';
import { FormViewStructuralWidget } from 'handie-vue/dist/widgets';
import defaultBehaviors from './behavior';
let DetailViewWidget = class DetailViewWidget extends FormViewStructuralWidget {
    isActionBarOutside() {
        if (isBoolean(this.config.actionBarOutside)) {
            return this.config.actionBarOutside;
        }
        return isBoolean(this.getBehavior('actionBarOutside'))
            ? this.getBehavior('actionBarOutside')
            : this.getCommonBehavior('view.objectViewActionBarOutside', false);
    }
    resolveActionBarAlignment() {
        if (this.config.actionBarAlignment) {
            return this.config.actionBarAlignment;
        }
        return (this.getBehavior('actionBarAlignment') ||
            this.getCommonBehavior('view.objectViewActionBarAlignment', 'left'));
    }
    render(h) {
        const outside = this.isActionBarOutside();
        const actionBar = this.renderActionBar(this.$style['DetailViewWidget-actionBar']);
        return h(getControl('Wait'), {
            props: {
                className: [
                    this.$style.DetailViewWidget,
                    this.$style[`DetailViewWidget--actionBar${capitalize(this.resolveActionBarAlignment())}`],
                    { [this.$style['DetailViewWidget--actionBarOutside']]: outside },
                    this.config.className,
                ],
                busy: this.loading,
            },
        }, outside
            ? [
                h('div', { class: this.$style['DetailViewWidget-formContainer'] }, [
                    this.renderForm({
                        className: this.$style['DetailViewWidget-form'],
                        readonly: true,
                    }),
                ]),
                actionBar,
            ]
            : [
                this.renderForm({
                    className: this.$style['DetailViewWidget-form'],
                    readonly: true,
                    children: [actionBar],
                }),
            ]);
    }
    created() {
        this.setBehaviors('view.detail', defaultBehaviors);
        this.fetchData();
    }
};
DetailViewWidget = __decorate([
    Component
], DetailViewWidget);
export default DetailViewWidget;
